// sleepDial
var initialValue = 30;
var innerRadius = 60;
var outerRadius = 100;

var offset = 120;

var valueArc = d3.svg.arc()
    .innerRadius(innerRadius)
    .outerRadius(outerRadius)
    .startAngle(0 * (Math.PI / 180)) //just radians
    .endAngle(initialValue * (Math.PI / 180));

var changeArc = d3.svg.arc()
    .innerRadius(innerRadius)
    .outerRadius(outerRadius)
    .startAngle(0 * (Math.PI / 180)) //just radians
    .endAngle(initialValue * (Math.PI / 180));

var interactArc = d3.svg.arc()
    .innerRadius(innerRadius)
    .outerRadius(outerRadius)
    .startAngle(0 * (Math.PI / 180)) //just radians
    .endAngle(360 * (Math.PI / 180));

function dragInteraction() {
    var x = d3.event.x - offset;
    var y = d3.event.y - offset;
    interaction(x, y, false)
}

function clickInteraction() {
    var coords = d3.mouse(this.parentNode);
    var x = coords[0] - offset;
    var y = coords[1] - offset;
    interaction(x, y, true)
}

function interaction(x, y, isFinal) {
    var arc = Math.atan(y / x) / (Math.PI / 180);
    if ((x >= 0 && y <= 0) || (x >= 0 && y >= 0)) {
        initialValue = 90 + arc;
    } else {
        initialValue = 270 + arc;
    }
    valueArc.endAngle(initialValue * (Math.PI / 180));
    d3.select('.valueArc').attr('d', valueArc);
    if (isFinal) {
        changeArc.endAngle(initialValue * (Math.PI / 180));
        d3.select('.changeArc').attr('d', changeArc);
    }
    d3.select('text').text(Math.round((24 / 360) * initialValue));
}

var svg = d3.select('.sleep')
    .append('svg');

svg.append('path')
    .attr('class', 'changeArc')
    .attr('d', changeArc)
    .attr('transform', 'translate(' + (offset) + ', ' + (offset) + ')');

svg.append('path')
    .attr('class', 'valueArc')
    .attr('d', valueArc)
    .attr('transform', 'translate(' + (offset) + ', ' + (offset) + ')');

var drag = d3.behavior.drag()
    .on('drag', dragInteraction)
    .on('dragend', clickInteraction)

svg.append('path')
    .attr('class', 'interactArc')
    .attr('d', interactArc)
    .attr('transform', 'translate(' + (offset) + ', ' + (offset) + ')')
    .on('click', clickInteraction)
    .call(drag);

svg.append('text')
   .text(Math.round((100 / 360) * initialValue))
   .attr('transform', 'translate(' + (offset - 10) + ', ' + (offset) + ')');
//end sleep dial